import wx
import os
import os.path
import glob
import zipfile
import zlib
import thread
import sys

__version__ = (0,0,3)
__build = (0,1)
__date__ = (2005,12,7)
__auteur__ = ('Guillaume','Duriaud')

## bogue: repertoire de destination a revoir

class wxZip(wx.App):
    def OnInit(self):
        self.dlg = wx.ProgressDialog("Zip",
                                "",
                                maximum = 100,
                                parent=None,
                                style = wx.PD_CAN_ABORT
                                | wx.PD_APP_MODAL
                                | wx.PD_ELAPSED_TIME
                                | wx.PD_REMAINING_TIME
                                )
        return True
    def _sizedirectory(self, path):
        """ Created: 2005.12.05 - Updated: 2005.12.06
            Calcul la taille totale du repertoire a compresser """
        for i in glob.glob(path+'\\*'):
            if not self.dlg.Update(-1,'Taille totale des fichiers a compresser: '+str(self.totsize)):
                self.dlg.Destroy()
                return False
            if os.path.isdir(i): self._sizedirectory(i) 
            else: self.totsize+=os.path.getsize(i)
        return True
    def _zipdirectory(self, path):
        """ Created: 2005.12.05 - Updated: 2005.12.06
            Ajoute les fichiers dans le zip """        
        for i in glob.glob(path+'\\*'):
            if not self.dlg.Update(100 * self.sizeencours / self.totsize,'Taille totale des fichiers a compresser: '+str(self.totsize) \
                                   +'\nTaille des fichiers compresses: '+str(self.sizeencours)):
                self.dlg.Destroy()
                return False
            if os.path.isdir(i): self._zipdirectory(i) 
            else:
                self.zfile.write(i)
                self.sizeencours += os.path.getsize(i)
        return True
    def Progresszip(self, namezip, pathzip):
        """ Created: 2005.12.05 - Updated: 2005.12.06
            Methode principale """         
        ## Calcul de la taille totale des fichiers a compresser
        self.dlg.Update(-1,'Calcul de la taile totale des fichiers a compresser')
        self.totsize = 0
        if not self._sizedirectory(pathzip): exit
        self.dlg.Update(-1,'Taille totale des fichiers a compresser: '+str(self.totsize))
        ## Creation du zip
        try: self.zfile = zipfile.ZipFile(namezip,'w',compression=zipfile.ZIP_DEFLATED)
        except: self.zfile = zipfile.ZipFile(namezip,'w')
        self.sizeencours = 0
        self.pathzip = pathzip
        ## Ajout des fichiers dans le zip
        if self._zipdirectory(pathzip): self.zfile.close()
        else: ## On a appuie sur Cancel, on supprimer le zip cree
            self.zfile.close()
            os.remove(namezip)
         
      

app = wxZip()
thread.start_new_thread(app.MainLoop,())
app.Progresszip('python.zip', 'c:\\python24')
app.Destroy()


