import os
import os.path
import glob
import zipfile
import zlib
import sys
import pygtk
import datetime as dt
pygtk.require('2.0')
import gtk, gobject 

__version__ = (0,0,3)
__build = (0,1)
__date__ = (2005,12,7)
__auteur__ = ('Guillaume','Duriaud')

## bogue: repertoire de destination a revoir

class gtkZip:
    def UpdatelblTimer(self):
        stoptime = dt.datetime.now()
        d = stoptime - self.starttime
        t = dt.time(d.seconds // 3600, (d.seconds % 3600) // 60, d.seconds % 60).strftime('%H:%M:%S')
        self.lblTimer.set_text('Temps ecoule: '+t)
        gtk.main_iteration()   
        return True
    def destroy_progress(self, widget, data=None):
        gobject.source_remove(self.timer)
        try: gobject.source_remove(self.start)
        except: pass
   	self.timer = 0
   	self.start = 0
   	gtk.main_quit()
    def __init__(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_resizable(False)

        self.window.connect("destroy", self.destroy_progress)
        self.window.set_title("Zip")
        self.window.set_border_width(0)

        vbox = gtk.VBox(False, 5)
        vbox.set_border_width(10)
        self.window.add(vbox)
        vbox.show()

        self.lblMessage = gtk.Label('')
        vbox.pack_start(self.lblMessage, True, True, True)
        self.lblMessage.show()
        self.lblMessage.set_alignment(0, 0)
        self.lblMessage2 = gtk.Label('')
        vbox.pack_start(self.lblMessage2, True, True, True)
        self.lblMessage2.show()
        self.lblMessage2.set_alignment(0, 0)

        # Create the ProgressBar
        self.pbar = gtk.ProgressBar()
        vbox.add(self.pbar)
        self.pbar.show()
        self.lblTimer = gtk.Label('Temps ecoule: 00:00:00')
        vbox.pack_start(self.lblTimer, True, True, True)
        self.lblTimer.show()
        self.lblTimer.set_alignment(0.5, 0)
        self.window.show()
    def _sizedirectory(self, path):
        """ Created: 2005.12.05 - Updated: 2005.12.06
            Calcul la taille totale du repertoire a compresser """
        gtk.main_iteration()
        if self.timer == 0: return False
        print self.timer        
        for i in glob.glob(path+'\\*'):
            if os.path.isdir(i): self._sizedirectory(i) 
            else: self.totsize+=os.path.getsize(i)
            self.lblMessage.set_text('Taille totale des fichiers a compresser: '+str(self.totsize))
        return True
    def _zipdirectory(self, path):
        """ Created: 2005.12.05 - Updated: 2005.12.07
            Ajoute les fichiers dans le zip """        
        gtk.main_iteration()
        if self.timer ==0: return False
        print self.timer
        for i in glob.glob(path+'\\*'):
            if os.path.isdir(i): self._zipdirectory(i) 
            else:
                self.zfile.write(i)
                self.sizeencours += os.path.getsize(i)
            self.lblMessage2.set_text('Taille des fichiers compresses: '+str(self.sizeencours))
            self.pbar.set_fraction(1.0 * self.sizeencours / self.totsize)
        return True
    def Progresszip(self, namezip, pathzip):
        """ Created: 2005.12.05 - Updated: 2005.12.07
            Methode principale """         
        ## Calcul de la taille totale des fichiers a compresser
        gobject.source_remove(self.start)
        self.starttime = dt.datetime.now()
        self.timer = gobject.timeout_add (1000, self.UpdatelblTimer)
        ##gtk.main_iteration()   
        self.totsize = 0
        if not self._sizedirectory(pathzip): exit
        self.lblMessage.set_text('Taille totale des fichiers a compresser: '+str(self.totsize))
        ##gtk.main_iteration() 
        ## Creation du zip
        try: self.zfile = zipfile.ZipFile(namezip,'w',compression=zipfile.ZIP_DEFLATED)
        except: self.zfile = zipfile.ZipFile(namezip,'w')
        self.sizeencours = 0
        self.pathzip = pathzip
        ## Ajout des fichiers dans le zip
        if self._zipdirectory(pathzip): self.zfile.close()
        else: ## On a appuie sur Cancel, on supprimer le zip cree
            self.zfile.close()
            os.remove(namezip)
        gobject.source_remove(self.timer)
        self.destroy_progress(self.window)
        return False
         
      

app = gtkZip()
app.start = gobject.timeout_add (100, app.Progresszip, 'python.zip', 'c:\\python24')
gtk.main()
gtk.main_quit()
exit


